/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file combinanodi.h :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#ifndef COMBINANODI_H
#define COMBINANODI_H


/**classe che permette la generazione di un array di numeri 
come generato da cicli annidati, in modo che tutti i nodi siano distinti ;

 necessario per trovare l'intersezione tra i nodi associati ad una operazione
  *@author 
  */

class combinaNodi {

public:
	combinaNodi(long numNodi,long nCicli);
	~combinaNodi();
	combinaNodi(const combinaNodi& i);  			//costruttore di copia
	combinaNodi& operator=(const combinaNodi& i);//assegnazione
		
	long getNumeroCicloCorrente()  {return numCicloCorrente;}//da 0 a numCicli-1
  long getArray(long*& l )       {l=punt;return numCicloCorrente+1;}

  long prossimaIterazioneCicloCorrente();//itera il ciclo corrente (-1 se impossibile)
  long aggiungiNuovoCiclo();//aggiunge un nuovo ciclo gia' inizializzato alla prima posizione(se possibile, else -1)
  long eliminaCicloCorrente();//elimina ultimo ciclo e torna al precedente (senza modificarlo)
	void stampa();
	
	long getValoreUltimoCiclo();//ritorna il valore dell'ultimo ciclo

private:
  long* punt;
  long  numNodi;
  long  numCicliTot;
  long  numCicloCorrente;

};

#endif
