/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file insiemeClique.h :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#ifndef insiemeClique_H
#define insiemeClique_H


/**
  *@author 
  */

class insiemeClique {
public: 
	insiemeClique(long* l,long n);    //inserisce per copia
	insiemeClique(long n);						//set la max dimensione
	insiemeClique(const insiemeClique& i);  			//costruttore di copia
	~insiemeClique();
	insiemeClique& operator=(const insiemeClique& i);//assegnazione
	
	long aggiungiInCoda(long l);//aggiunge alla fine se possibile (-1 se spazio esaurito)
	long getArray(long*& l);  	//punta all'array interno e ritorna il num di elementi presenti
  static insiemeClique intersezioneInsiemiOrdinati(insiemeClique& i1, insiemeClique& i2);//vale solo se gli insiemi sono ordinati in senso crescente
  void stampa();
  void svuota(){ posLibera=0;}//svuota l'insiemeClique
private:
  long posLibera;
  long maxDim;
  long* punt;

  static long minimo(long, long);
};

#endif
