/*

*********************************************************************
*********************************************************************

  common functions and classes of all graph utilities

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/

#ifndef INCLUDE_ALL_COMMON_HEADERS_
#define INCLUDE_ALL_COMMON_HEADERS_

#include"./coda.h"
#include"./externalbuffer.h"

#include"./externalSort/externalSort.h"
#include"./externalSort/infoBlocco.h"
#include"./externalSort/multiCoda.h"
#include"./externalSort/ordina.h"
#include"./funzioniGenerali.h"
#include"./genRandom.h"
#include"./indeg.h"
#include"./insieme.h"
#include"./multiSemaforo.h"
#include"./processi.h"
#include"./randomGen2.h"
#include"./report2.h"
#include"./report.h"
#include"./semaforo.h"
#include"./streamFiles/bufferedThreadFileInputStream.h"
#include"./streamFiles/bufferedThreadFileOutputStream.h"
#include"./streamFiles/multiFileAppend.h"
#include"./streamFiles/multiFileReader.h"
#include"./streamFiles/multiFileWriter.h"
#include"./streamFiles/multiFile.h"
#include"./streamFiles/seekmultifilein.h"
#include"./vettorefile.h"
#include"./binvector.h"
#include"./binvectorfile.h"

#include"./infoTree.h"
#include"./infoNode.h"
#include"./infoNodeScc.h"
#include"./labelInfoNodeScc.h"
#include"./infoScc.h"
#include"./arco.h"
#include"./timer.h"

#endif
