/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file seekmultifilein.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <string.h>
#include <stdio.h>
//#include <iostream.h>
#include <iostream>
#include <sys/stat.h>


#ifndef SEEKMULTIFILEIN_H
#define SEEKMULTIFILEIN_H


class seekMultiFileIn {
private:
  long* numBytePerFile;
  long  numFiles;
  char  nomeFile[1000];
  bool  chiuso;
  long  numFileAperto;
  FILE* f;

  long contaNumFilesMultiFileLoc(char* nome);
  long getFileSize(char* nomeFile);

private:
  long apriSingoloFile(long numFileDaAprire, long posSeek);
  long trovaNumeroFile(long long posizioneInByte, long& posRelativaFile);

public:
	
  seekMultiFileIn(char* nome);
  seekMultiFileIn(){chiuso=true;f=NULL;}
  long leggi( unsigned char* buffer, long sizeElemento,long numElementi,long long posSeekInizialeInByte);
  long long getSizeTotaleInByte();
  long getNumeroFiles();
  long getSizeFileI_esimo(long i);
	void chiudi();

};

#endif
