/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file config.h :source code of layermodel utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/*

liv 0											X  X  X
                          /   \  \-------\
                         /     \          \
liv 1                x  x  x | x  x  x | x x x


*/
#ifndef COEFF_LIV_0

#define COEFF_LIV_0    (50)
#define COEFF_LIV_1    (70)
#define COEFF_LIV_2    (100)           /*livello a contatto con i nodi*/





#define DIM_MAX  (262144000*8)
#define MAX_ITER  (100000)
#define TEST_MEMORIA if (RAM<=MB ){cerr<<"Memoria insufficiente";FINE;}

//num layer gestiti contemporaneamente nella suddivisione dei nodi
#define NUM_LAYER_CONTEMPORANEI  /*(50)*/(50)


//dim in byte della memoria da utlizzare (< di quella massima possibilmente)
//#define RAM_LIBERA   ( getMemoriaDisponibile() )
//#define MB   (1048576)

//ram effettivamente usata...
//#define RAM  (  (long)(RAM_LIBERA)   )




#define NUM_BUFFER         (6)
#define DIM_BUFFER         (6*1024)

//max outdeg nella generazione...
#define MAX_OUTDEGREE_GENERATORE  (10000)

//specifica se devo forzare il completamento dei successori per i nodi,
//cioe' ripeto i lanci finche' non trovo un successore valido... Cio' significa che
//   1) se ho scelto per copia un successore non esistente riprovo (eventualmente provando anche scelta indegree)
//   2) se ho scelto un arco gia' presente semplicemente non lo prendo (SENZA RIPETERE)

//in particolare potendo scegliere tra scelta casuale e copia ripeto finche' non termino
// NON SCEGLIERE PERCHE' SEMBRA CHE IL MODELLO VADA PEGGIO
//#define COMPLETA_SUCCESSORI


#endif


