/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file grafo.h :source code of layermodel utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   

#ifndef GRAFO_H
#define GRAFO_H

#include "comuni.h"


class grafo {

private:
  long numNodi;
  long **succ;//contiene i succ x ogni nodo (il 1 elem contiene il num di successori)

public:
	grafo(long nNodi);
	void cancella();
  long getSuccNodo(long nodo,long posSucc);
  long addSucc(long nodo, long nodoSucc);
  void setMaxSuccNodo(long nodo,long nSucc);//permette di specificare che un dato nodo avra' al max i succ specificati
};

#endif
