/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file utilityModel.cpp :source code of layermodel utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "utilityModel.h"

// ##########################################################################################################################################################
// ##########################################################################################################################################################
// ##########################################################################################################################################################
float normalizzaLancioFloat(unsigned long lancio, float inferiore, float superiore){
    float diff=superiore-inferiore;
    if (diff<0) return 0;
    float f = 1.0*lancio/RAND_MAX; //valore tra 0 e 1, compresi gli estremi
    return inferiore+f*diff;
}


long normalizzaLancio(unsigned long lancio, long inferiore, long superiore){
    long diff=superiore-inferiore;
    if (diff<0) return 0;
    return (long)(inferiore+lancio%(diff+1));
}



void generaNomeTempoNodiPerLayer(char*s,long layer,char* nomeGrafo){
       strcpy(s,nomeGrafo);
       char b[1000];
       sprintf(b,".TempoNodiLayerNum_%ld",layer);
       strcat(s,b); //tipo di nome --> nomegrafo%d.TempoNodiLayerNum_3  se ho il 3 layer
}

void generaNomeTempoArchiPerLayer(char*s,long layer,char* nomeGrafo){
       strcpy(s,nomeGrafo);
       char b[1000];
       sprintf(b,".TempoArchiLayerNum_%ld",layer);
       strcat(s,b); //tipo di nome --> nomegrafo%d.TempoNodiLayerNum_3  se ho il 3 layer
}

