/*

*********************************************************************
*********************************************************************

  file accessovirtualearchi.cpp :source code of utl_sccgraphconstructor utility

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/


#include "accessovirtualearchi.h"

accessoVirtualeArchi::accessoVirtualeArchi(){
  finito=false;
  posCorrenteNuovoArco=0;
  sizeBufferUsato=0;
}


arco* accessoVirtualeArchi::getNuovoArco(){
  if (finito) return NULL;

  //controlla se il buffer e' vuoto
  if (posCorrenteNuovoArco>=sizeBufferUsato){
    //prova a riempirlo nuovamente
    readNewBuffer(buffer,sizeBufferUsato);
    posCorrenteNuovoArco=0;
  }

  //controlla se ci sono elementi disponibili (se no --> file input terminato)
  //controlla se il buffer e' vuoto
  if (posCorrenteNuovoArco>=sizeBufferUsato){
    finito=true;
    //printf("FINE \n");
    return NULL;
  }
  else
    return &buffer[posCorrenteNuovoArco++];
}
