/*

*********************************************************************
*********************************************************************

  file accessovirtualearchi.h :source code of utl_sccgraphconstructor utility

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/

#ifndef ACCESSOVIRTUALEARCHI_H
#define ACCESSOVIRTUALEARCHI_H


/**Permette di accedere agli archi di un file che e' in formato ips o edges...
  */

#include "comuni.h"
#define SIZE_BUFFER_accessoVirtualeArchi (1000)

class accessoVirtualeArchi {
protected:

  //legge i dati nel buffer
  virtual void readNewBuffer(arco* buffer,long& sizeBufferUsato)=0;

  bool finito;
  long posCorrenteNuovoArco;//pos arco corrente da ritornare
  long sizeBufferUsato;     //size del buffer attualmente occupata
  arco buffer[SIZE_BUFFER_accessoVirtualeArchi];//buffer degli archi
  accessoVirtualeArchi();
public:
  arco* getNuovoArco();
  virtual void close()=0;
  virtual long long getNumeroArchiTotali()=0;
  
};



#endif
