/*

*********************************************************************
*********************************************************************

  file accessovirtualearchi_edges.h :source code of utl_sccgraphconstructor utility

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/

#ifndef ACCESSOVIRTUALEARCHI_EDGES_H
#define ACCESSOVIRTUALEARCHI_EDGES_H

#include "accessovirtualearchi.h"

/**
  *@author root
  */

class accessoVirtualeArchi_EDGES : public accessoVirtualeArchi  {

private:
  multiFileReader archi;

public:
	accessoVirtualeArchi_EDGES(char* edge);
  void readNewBuffer(arco* buffer,long& sizeBufferUsato);
  void close() {archi.close();}
  long long getNumeroArchiTotali(){ return getTotalSizeMultiFiles( archi.getMultiFileName() )/sizeof(arco); }
};

#endif
