#include "comuni.h"

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//  stampa i parametri d'uso
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
//01234567890123456789012345678901234567890123456789012345678901234567890123456789
void stampaHelp(int arg,char* argv[]){
    cout<<"This utility is not designed for stand alone use. It's used as a part of others utilities.\n";
    cout<<"\n";
		cout<< "This utility sort an edges format multifile. Possible sorting are: (1)sort by source node (2) sort by destination node\n";
		cout<< " \n";
		cout<< "Usage: utl_externalsort memory -savesource|-deletesource -source|-dest nameInputMultifile%d nameTempMultifile%d nameOutputMultifile%d\n";
		cout<< " \n";
		cout<< "memory                     memory available(MB)\n";
		cout<< "-savesource|-deletesource  specify whether to delete or keep the input file\n";
    cout<< "-source|-dest              sorting by source node or destination node\n\n";
		cout<< "nameInputMultifile%d       name of the multifile of the input graph (edges format)\n";
    cout<< "nameTempMultifile%d        name of the temp multifile\n";
    cout<< "nameOutputMultifile%d      name of the output multifile (edges format)\n";
    arg=0;argv=NULL;

 }


//NOTA multifile = + file che rapresentano lo stesso file ma con nomi sequenziali
int main(int arg,char** argv)
{

    stampaLicenza(arg,argv);
    if (arg<1) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");

     long scelta=0;
     if (arg<=2)
        scelta=0;
     else
	     if (strcasecmp(argv[1+1],"-saveSource")==0 || strcasecmp(argv[1+1],"-deleteSource")==0)        scelta=1;
       else  scelta=0;



     switch(scelta){
       //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
       case 0: {
         STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");
         break;
       }

       //XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
       case 1:{// ordinamento

         if (arg!=7) STAMPA_ERRORE_PARAMETRI(argv[0],"Incorrect parameters.");

         long cancellaSource;
         if (strcasecmp(argv[2],"-saveSource")==0)  cancellaSource=FALSE;
         else
            if (strcasecmp(argv[2],"-deleteSource")==0)  cancellaSource=TRUE;
            else  STAMPA_ERRORE_PARAMETRI(argv[0],"-deleteSource e -saveSource not found");

         long tipo=2;

         if (strcasecmp(argv[3],"-source")==0)  tipo=1;
         else
            if (strcasecmp(argv[3],"-dest")==0)  tipo=2;
            else  STAMPA_ERRORE_PARAMETRI(argv[0],"opzioni -souce e -dest non indicate");

         //long num=contaNumFilesMultiFile(argv[4]);

         //************************ CONTROLLO FILES DI INPUT ***************************
         if (getTotalSizeMultiFiles(argv[4])<=0){cout<<"The input graph is empty\n";FINE};

         //il nome del file tempo, lo ricavo da quello dell'output aggiungendo ".tempo" alla fine
         char* nomeFileTemporaneo=argv[5];


         long memoria=(long)atof(argv[1])*1024*1024;
         setMemoriaDisponibile(memoria);
      	 //TEST_MEMORIA;

         if (!estMultiFileName(argv[4])) STAMPA_ERRORE_PARAMETRI(argv[0],(char*)"Input filename must contain the substring '%d' ");
         if (!estMultiFileName(argv[5])) STAMPA_ERRORE_PARAMETRI(argv[0],(char*)"Input filename must contain the substring '%d' ");
         if (!estMultiFileName(argv[6])) STAMPA_ERRORE_PARAMETRI(argv[0],(char*)"Input filename must contain the substring '%d' ");


         long param_RAM=RAM;
         long param_DIM_BUFFER_THREAD_IO_EXTERNALSORT=128*1024;
         long param_NUM_BUFFER_THREAD_IO_EXTERNALSORT=10;
         long param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT=128*1024;
         long param_MAX_NUM_THREAD_QSORT_EXTERNALSORT=20;
         long param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT=30;

         if (tipo==2)//ordina per destinazione
        		externalSort_arco32dest ( argv[4], nomeFileTemporaneo, argv[6],cancellaSource,(char*)"\nEdges sorted by destination node",
                                      param_RAM,param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,
                                      param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                                      param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,true);
         else//ordina per sorgente
        		externalSort_arco32sorg ( argv[4], nomeFileTemporaneo, argv[6],cancellaSource,(char*)"\nEdges sorted by source node",
                                      param_RAM,param_DIM_BUFFER_THREAD_IO_EXTERNALSORT,
                                      param_NUM_BUFFER_THREAD_IO_EXTERNALSORT,param_DIM_BUFFER_NOTHREAD_IO_EXTERNALSORT,
                                      param_MAX_NUM_THREAD_QSORT_EXTERNALSORT,param_NUM_FILE_CONTEMPORANEI_MERGE_EXTERNALSORT,true);

         //aspetta che tutto termini
         EXIT(0);
         break;
       }
     };

     EXIT(0);
     return 0;
}
