/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file config.h :source code of clique utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "comuni.h"

#ifndef _CONFIG_CLIQUE
#define _CONFIG_CLIQUE


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXX PARAMETRI MODIFICABILI DALL'UTENTE XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/*n di iterazioni prima di stampare il messaggio su video - usato per gli indici di avanzamento*/
#define MAX_ITER   (500000)

//NMASSIMO BYTE SINGOLO FILE (multiplo di 8 per far si che ci siano un n intero di nodi sia da 32 che 64 bit)
#define MAX_DIM_OUTPUT   (262144000*8)

//dim in byte della memoria da utlizzare (< di quella massima possibilmente)
//#define RAM_LIBERA   ( getMemoriaDisponibile() )

//specifica se calcolare le clique solo se l'operazione e' completa (consigliata)
//#define ESEGUI_SOLO_SE_COMPLETO

//specifica se usare seek o leggere comunque...
//#define USA_SEEK_LETTURA_PRED_SUCC

//massimo n di files contemporanemaente aperti in scrittura (1 x blocco )
#define MAX_NUM_FILE_APPEND  (60)

//max numero di operazioni nuove che possono essere aggiunte ad ogni scansione di un blocco
#define MAX_NUM_OPERAZIONI_NUOVE_TOTALI (10000000)

//dimensione e numero dei buffer per i thread di lettura DAL FILE DEI CODICI (RAM SISTEMA)
#define DIM_BUFFER_LETTURA_GENERICA  (MB/2)
#define NUM_BUFFER_LETTURA_GENERICA  (3*2)

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

#define TEST_MEMORIA if (RAM<=MB ){cerr<<"Memoria insufficiente";FINE;}

#endif


