/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file infoBlocco.h :source code of externalsort utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#ifndef _INFOBLOCCO_XXX
#define _INFOBLOCCO_XXX
// classe che contiene le info su ogni blocco creato
// SENZA CONDIVISIONE
class infoBlocco{
  public:
    long numeroBlocco;//nblocco corrente
    long numeroFiles;//n files creati per quel blocco
    long long sizeInByte;
    char prototipoMultiFile[N];

    infoBlocco(){;}

    //costruttore di copia
    infoBlocco(infoBlocco& b){
        this->numeroBlocco=b.numeroBlocco;
        this->numeroFiles=b.numeroFiles;
        this->sizeInByte=b.sizeInByte;
        strncpy(this->prototipoMultiFile,b.prototipoMultiFile,N);
    }

    infoBlocco(long nBlocco,long nFiles,char* prototipo,long long sByte){
        numeroBlocco=nBlocco;
        numeroFiles=nFiles;
        sizeInByte=sByte;
        strncpy(prototipoMultiFile,prototipo,N);

        }
    friend std::ostream& operator<<(std::ostream&,infoBlocco&);
};

/*
std::ostream& operator<<(std::ostream& out ,infoBlocco& a){
  return out<<"[("<<a.numeroBlocco<<"),"<<a.numeroFiles<<" - "<<a.prototipoMultiFile<<"]";
} */


#endif
