/*

*********************************************************************
*********************************************************************

  common functions and classes of all graph utilities

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/

#ifndef INCLUDE_ALL_COMMON_OBJS
#define INCLUDE_ALL_COMMON_OBJS

#include"./streamFiles/multiFileAppend.cc"

#include"./binvector.cpp"
#include"./binvectorfile.cpp"
#include"./externalbuffer.cpp"
#include"./funzioniGenerali.cc"
#include"./indeg.cpp"
#include"./insieme.cpp"
#include"./multiSemaforo.cc"
#include"./processi.cc"
#include"./randomGen2.cpp"
#include"./report2.cpp"
#include"./report.cpp"
#include"./semaforo.cc"

#include"./streamFiles/bufferedThreadFileInputStream.cc"
#include"./streamFiles/bufferedThreadFileOutputStream.cc"
#include"./streamFiles/multiFileReader.cc"
#include"./streamFiles/multiFileWriter.cc"
#include"./streamFiles/multiFile.cpp"
#include"./streamFiles/seekmultifilein.cpp"


#include"./arco.cc"
#include"./timer.cpp"
#include"./externalSort/externalSort.cc"


#endif

