/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file infoNode.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
*/                                                                   

/*
For each node of the graph it hold: indegree, outdegree, pounter to pred 
(is an index that is index 1 is the first node,index 2 is the second etc.
Each pointer seek 1 long each time !!!
The number of node is the position of each record. The 1° record is for node 0, the second for node 1 etc
*/
#ifndef INFONODO_H
#define INFONODO_H

class infoNodo {
public: 
  long inDeg;
  long outDeg;
  long long puntIn; //punt in long
  long long puntOut;//punt in long
};


#endif
