/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file insieme.cpp :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          insieme.cpp  -  description
                             -------------------
    begin                : Thu Jun 13 2002
    copyright            : (C) 2002 by root
    email                : root@travelcat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "insieme.h"
#include <stdio.h>

insieme::insieme(long sizeMax){

  this->sizeMax=sizeMax;
  this->size=0;
  punt = new long[sizeMax];

}



void insieme::cancella(){
    if (this->punt==NULL) return;
    delete[] punt;punt=NULL;
    this->size=0;
}



long insieme::aggiungiElemento(long elem){
   if (this->punt==NULL) return -1;
   if (size<this->sizeMax){
      punt[size]=elem;
      size++;
      return size-1;//ritorna la pos in cui si trova
   }
   return -1;
}



long insieme::getPosizioneElemento(long elem){

   if (this->punt==NULL) return -1;
   for (long i=0;i<size;i++)
      if (punt[i]==elem) return i;
   return -1;
}

