/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file randomGen2.h :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
//#include "comuni.h"
#include <stdio.h>
// randomGen2.h: interface for the randomGen2 class.
//
//////////////////////////////////////////////////////////////////////

#ifndef AFX_RANDOMGEN2_H__41BBAFE8_1EE1_42A4_8BE9_0D94CC6CA75E__INCLUDED_
#define AFX_RANDOMGEN2_H__41BBAFE8_1EE1_42A4_8BE9_0D94CC6CA75E__INCLUDED_

//num buffer da gestire
#define NUM_BUFFER_RANDOM (1000)

class randomGen2  
{
private:
	unsigned long * lista[NUM_BUFFER_RANDOM];//puntatori ai valori random precalcolati
 	long periodo;
  long sizePerBlocco;
  long seed;
  long long puntCont;

public:
	randomGen2(long seed, long periodo);
  void resetSeed();
	randomGen2();
	randomGen2(long seed);

	unsigned long genRand(long long pos);
	unsigned long genrand();

	void cancella();
  unsigned long getPeriodo(){return this->periodo;}



};

#endif // !defined(AFX_RANDOMGEN2_H__41BBAFE8_1EE1_42A4_8BE9_0D94CC6CA75E__INCLUDED_)
