/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file report.cpp :common functions and classes of all graph utilities
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          report.cpp  -  description
                             -------------------
    begin                : Tue Feb 12 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "report.h"

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void report::leggeControllatoFileReport(char* aux,FILE* fp,int numRiga,char* nomeFileReport){
	
	if (fgets(aux,1000,fp)==NULL){//leggo la stringa corrente
	    std::cout<<"Errore durante la lettura della riga "<<numRiga<<" nel file "<<nomeFileReport<<":";
	    printError("");
	    FINE;
	}
	
	int lung=strlen(aux);
	int posInizio=lung;
	int posFine=lung;
	
	//trovo l'inizio della stringa
	for (int i=0;i<lung;i++)
	   //controllo quando inizia la stringa (salto spazi e \n)
	   if (aux[i]>32)   {posInizio=i;break;}
	                 	
	//trovo la fine della stringa
	for (int j=lung-1;j>posInizio;j--)
		 //controllo quando inizia la stringa (salto spazi e \n)
	   if (aux[j]>32)   {posFine=j;break;}

	//std::cout<<"\n<"<<aux<<"> inizio "<<posInizio<<" - fine "<<posFine;
	//copio la parte della stringa significativa all'inizio
	int pos=0;
	for (int i=posInizio;i<=posFine;i++)
	   aux[pos++]=aux[i];
	                 	
	//termino la stringa con \0
	aux[pos]=0;
	
}


report::report(char* nomeFileReport){
	
  int num=1;

	FILE * fp=fopen(nomeFileReport,"r+");
	char aux[1000];
	if (fp==NULL){
  	  std::cout<<"Errore nell'apertura del file report "<<nomeFileReport<<": ";
	    printError("");
	    FINE;
	}
	
	
	

	//_________________ NUM NODI ___________________________	
	//commento
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
  //leggo numero nodi
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//converte il numero di nodi
	errno=0;
	numNodi=strtol(aux,NULL,10);
	if (errno!=0){
	    std::cout<<"Errore nel calcolo del numero di files info (riga "<<num<<" del file "<<nomeFileReport<<" )";
	    FINE;
	}
	
	
	
	
	//_________________ NUM ARCHI ___________________________	
	//commento
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
  //leggo numero nodi
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//converte il numero di nodi
	numeroArchi=0;
	int lung=strlen(aux);
	for (int i=0;i<lung;i++)
	    numeroArchi=numeroArchi*10 + (aux[i]-'0');
	
//	std::cout<<numeroArchi<<"\n";
	
	



	//__________ MAX DIM _________________________________________

  //commento
	leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//numero di files info
	leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//converte il numero di nodi
	errno=0;
	dimensioneMaxFiles=strtol(aux,NULL,10);
	if (errno!=0){
	    std::cout<<"Errore nel calcolo del numero di files info (riga "<<num<<" del file "<<nomeFileReport<<" )";
	    FINE;
	}


  //__________ NOME GRAFO _________________________________________

	//commento
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);

  //legge il nome del file info
  leggeControllatoFileReport(nomeFilesInfo,fp,num++,nomeFileReport);


	//commento
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//numero di files info
	leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//converte il numero di nodi
	errno=0;
	numFilesInfo=strtol(aux,NULL,10);
	if (errno!=0){
	    std::cout<<"Errore nel calcolo del numero di files info (riga "<<num<<" del file "<<nomeFileReport<<" )";
	    FINE;
	}
	
	
	
	
	//__________ NOME SUCC _________________________________________

	//commento
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);

  //legge il nome del file info
  leggeControllatoFileReport(nomeFilesSucc,fp,num++,nomeFileReport);

  //commento sul numero di files info
	leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//numero di files info
	leggeControllatoFileReport(aux,fp,num++,nomeFileReport);
	
	//converte il numero di nodi
	errno=0;
	numFilesSucc=strtol(aux,NULL,10);
	if (errno!=0){
	    std::cout<<"Errore nel calcolo del numero di files info (riga "<<num<<" del file "<<nomeFileReport<<" )";
	    FINE;
	}
	
	
	
	
	//__________ NOME PRED _________________________________________

	//commento
  leggeControllatoFileReport(aux,fp,num++,nomeFileReport);

  //legge il nome del file info
  leggeControllatoFileReport(nomeFilesPred,fp,14,nomeFileReport);

  //commento sul numero di files info
	leggeControllatoFileReport(aux,fp,15,nomeFileReport);
	
	//numero di files info
	leggeControllatoFileReport(aux,fp,16,nomeFileReport);
	
	//converte il numero di nodi
	errno=0;
	numFilesPred=strtol(aux,NULL,10);
	if (errno!=0){
	    std::cout<<"Errore nel calcolo del numero di files info (riga "<<num<<" del file "<<nomeFileReport<<" )";
	    FINE;
	}
	
	fclose(fp);	

	
}
