/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multifilewritertxt.cpp :source code of correlation utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
/***************************************************************************
                          multifilewritertxt.cpp  -  description
                             -------------------
    begin                : Tue Nov 12 2002
    copyright            : (C) 2002 by stefano millozzi
    email                : stefano@travelcat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "multifilewritertxt.h"


multiFileWriterTXT::multiFileWriterTXT(char* nomeF,long nRigheMax){

   //inizializzo x avere un file gia' pieno (cosi' comincio da capo)
   this->numFileCorrente=-1;
   this->numRigheCorrenti=this->numRigheMax=nRigheMax;
   strcpy(nome,nomeF);
   fp=NULL;
   this->chiuso=false;

}


//aggiunge una riga (con \n gia' incluso
void multiFileWriterTXT::scriviStringa(char* txt){
  if (numRigheCorrenti==numRigheMax){
    //cambio file (prendo il successivo)
    if (fp!=NULL) fclose(fp);
    char app[1000];sprintf(app,nome,++numFileCorrente);
    if ( (fp=fopen(app,"w"))==NULL ){printError("");FINE;}
    numRigheCorrenti=0;
  }

  numRigheCorrenti++;
  fwrite(txt,sizeof(char),strlen(txt),fp);
}



//chiude il file
long  multiFileWriterTXT::chiudi(){
  if (chiuso) return numFileCorrente+1;
  if (fp!=NULL) fclose(fp);
  chiuso=true;
  return numFileCorrente+1;
}
