/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file multifilewritertxt.h :source code of correlation utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include <stdio.h>
#include <string.h>
#include "comuni.h"
#include "config.h"
/***************************************************************************
                          multifilewritertxt.h  -  description
                             -------------------
    begin                : Tue Nov 12 2002
    copyright            : (C) 2002 by stefano millozzi
    email                : stefano@travelcat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MULTIFILEWRITERTXT_H
#define MULTIFILEWRITERTXT_H


/**
  *@author stefano millozzi
  */

class multiFileWriterTXT {

private:
  FILE* fp;
  long numFileCorrente;
  long numRigheCorrenti;
  long numRigheMax;
  char nome[1000];
  bool chiuso;
  
public: 
	multiFileWriterTXT(char* multiFile, long numRigheMax);
  multiFileWriterTXT(){numFileCorrente=-1;chiuso=true;}
	long chiudi();
  void scriviStringa(char* txt);
  
};

#endif
