/*                                                                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
  file bufferizzazionelistafiles.h :source code of pagerank utility
                                                                     
  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi                
  email      (millozzi,laura,leon)@dis.uniroma1.it                   
                                                                     
*********************************************************************
*********************************************************************
                                                                     
* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *
                                                                     
*********************************************************************
*********************************************************************
                                                                     
*/                                                                   
#include "comuni.h"
#ifndef BUFFERIZZAZIONELISTAFILES_H
#define BUFFERIZZAZIONELISTAFILES_H


/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*gestisce la bufferizzazione dei files*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
class bufferizzazioneListaFiles{
  private:
    multiFileWriter* out;
    long** buffer;
    long*  numElemBuffer;
    long   sizeTotBuffer;
    long   nBlocchi;
    bool   chiuso;
  public:
    //postfisso e' la stringa con %d da aggiungere alla fine per spec i blocchi
    bufferizzazioneListaFiles(char* multiNome,char* postFisso,long nBlocchi, long sizeBuffer,long dimMassimaFilesInByte);
    static void calcolaNomeFileBlocco(long nBlocco,char* nome,char* postFisso,char* dest);
    void scrivi(long valore, long nBlocco);
    void chiudi(long* nFilesPerBlocco);
  private:
    static void scriviBuf(long valore, long* buf, long& numElementiBuffer, long maxNumElem, multiFileWriter& f);
};


#endif
