/*

*********************************************************************
*********************************************************************

  file accessovirtualearchi_ips.h :source code of utl_sccgraphconstructor utility

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/

#ifndef ACCESSOVIRTUALEARCHI_IPS_H
#define ACCESSOVIRTUALEARCHI_IPS_H

#include "accessovirtualearchi.h"

/**
  *@author root
  */

class accessoVirtualeArchi_IPS : public accessoVirtualeArchi  {

private:
  multiFileReader f_info;
  multiFileReader f_succ;

  long nodoCorrente;//nodo corrente letto a cui si riferiscono i succ da leggere
  long bufferSucc[SIZE_BUFFER_accessoVirtualeArchi];//buffer di appoggio per la lettura dei successori - stessa size del buffer degli archi
  long numSuccRimastiDaLeggere;

public: 
	accessoVirtualeArchi_IPS(char*info,char* succ);
  void readNewBuffer(arco* buffer,long& sizeBufferUsato);
  void close() {f_info.close(); f_succ.close();}
  long long getNumeroArchiTotali(){ return getTotalSizeMultiFiles(f_succ.getMultiFileName() )/sizeof(long); }

};

#endif
