/*

*********************************************************************
*********************************************************************

  file funzioni.h :source code of utl_sccgraphconstructor utility

  Copyright  (C) 2003 S.Millozzi, L.Laura, S.Leonardi
  email      (millozzi,laura,leon)@dis.uniroma1.it

*********************************************************************
*********************************************************************

* This program is free software; you can redistribute it and/or     *
* modify it under the terms of the GNU General Public License       *
* as published by the Free Software Foundation; either version 2    *
* of the License, or (at your option) any later version.            *
*                                                                   *
* This program is distributed in the hope that it will be useful,   *
* but WITHOUT ANY WARRANTY; without even the implied warranty of    *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
* GNU General Public License for more details.                      *
*                                                                   *
* You should have received a copy of the GNU General Public License *
* along with this program; if not, write to the Free Software       *
* Foundation, Inc., 59 Temple Place -                               *
* Suite 330, Boston, MA  02111-1307, USA.                           *

*********************************************************************
*********************************************************************

*/


//#include <iostream.h>
#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include "comuni.h"
#include "accessovirtualearchi_ips.h"
#include "accessovirtualearchi_edges.h"


//numero di iterazioni da effettuare prima della stampa
#define ITERATOR_STAMPA (500000)


void etichettaNodi_infoNodeScc(
        char* sccINFO, char* sccSUCC,
        char* grafoINFO,
        char* INset,char* OUTset, char* DISCset, char*TENDRILSset, char* TUBESset,
        char* temp,
        long MAX_DIM_FILE,long memoria,
        long minSccSize, char*outputSccRegion);


void calcolaLabelSCC_InfoScc(
                     char* fileInfoNodeScc,//file contenente i record InfoNodeScc
                     char* temp,
                     long MAX_DIM_FILE,long available_RAM,
                     char* labelSccGraph//ritorna il file delle label
                     );

void calcolaGrafoSCC(
        char* sccINFO, char* sccSUCC,
        char* grafoINFO,char* grafoSUCC,
        char* INset,char* OUTset, char* DISCset, char*TENDRILSset, char* TUBESset,
        char* temp,
        long MAX_DIM_FILE,long available_RAM,
        long minSccSize, char* sccGraph);

void  calcolaDistribuzione(char* sccINFO, char* sccSUCC, char* grafoINFO,
            char* INset, char* OUTset, char* DISCset, char* TENDRILSset, char* TUBESset,
            char* temp, long MAX_DIM_FILE, long memoria, char* report);
